package cn.com.infosec.asn1;

import java.io.ByteArrayOutputStream;
import java.io.EOFException;
import java.io.IOException;
import java.io.InputStream;
import java.util.Vector;

/** @deprecated */
public class BERInputStream extends DERInputStream {
   private static final DERObject END_OF_STREAM = new DERObject() {
      void encode(DEROutputStream out) {
         throw new IOException("Eeek!");
      }

      public int hashCode() {
         return 0;
      }

      public boolean equals(Object o) {
         return o == this;
      }
   };

   public BERInputStream(InputStream is) {
      super(is);
   }

   private byte[] readIndefiniteLengthFully() {
      ByteArrayOutputStream var1;
      var1 = new ByteArrayOutputStream.<init>();

      int var3;
      for(int var2 = this.read(); (var3 = this.read()) >= 0 && (var2 != 0 || var3 != 0); var2 = var3) {
         var1.write(var2);
      }

      return var1.toByteArray();
   }

   private BERConstructedOctetString buildConstructedOctetString() {
      Vector var1;
      var1 = new Vector.<init>();

      DERObject var2;
      while((var2 = this.readObject()) != END_OF_STREAM) {
         var1.addElement(var2);
      }

      return new BERConstructedOctetString(var1);
   }

   public DERObject readObject() {
      int var1;
      if ((var1 = this.read()) == -1) {
         throw new EOFException();
      } else {
         int var2;
         byte[] var5;
         if ((var2 = this.readLength()) >= 0) {
            if (var1 == 0 && var2 == 0) {
               return END_OF_STREAM;
            } else {
               BERInputStream var12 = this;
               this.readFully(var5 = new byte[var2]);
               return var12.buildObject(var1, var5);
            }
         } else if (var1 == 5) {
            return null;
         } else if (var1 == 36) {
            return this.buildConstructedOctetString();
         } else {
            DERObject var9;
            if (var1 != 48) {
               if (var1 != 49) {
                  if ((var1 & 128) == 0) {
                     throw new IOException("unknown BER object encountered");
                  } else if ((var2 = var1 & 31) == 31) {
                     throw new IOException("unsupported high tag encountered");
                  } else if ((var1 & 32) == 0) {
                     var5 = this.readIndefiniteLengthFully();
                     DEROctetString var10;
                     var10 = new DEROctetString.<init>(var5);
                     return new BERTaggedObject(false, var2, var10);
                  } else {
                     DERObject var3;
                     DERObject var8;
                     if ((var8 = this.readObject()) == (var3 = END_OF_STREAM)) {
                        return new DERTaggedObject(var2);
                     } else {
                        DERObject var4;
                        if ((var4 = this.readObject()) == var3) {
                           return new BERTaggedObject(var2, var8);
                        } else {
                           BERConstructedSequence var11;
                           BERConstructedSequence var10000 = var11 = new BERConstructedSequence;
                           var10000.<init>();
                           var10000.addObject(var8);

                           do {
                              var11.addObject(var4);
                           } while((var4 = this.readObject()) != END_OF_STREAM);

                           return new BERTaggedObject(false, var2, var11);
                        }
                     }
                  }
               } else {
                  ASN1EncodableVector var7;
                  var7 = new ASN1EncodableVector.<init>();

                  while((var9 = this.readObject()) != END_OF_STREAM) {
                     var7.add(var9);
                  }

                  return new BERSet(var7);
               }
            } else {
               BERConstructedSequence var6;
               var6 = new BERConstructedSequence.<init>();

               while((var9 = this.readObject()) != END_OF_STREAM) {
                  var6.addObject(var9);
               }

               return var6;
            }
         }
      }
   }
}
